/*
        IcuKrell 0.0.1a - drJeckyll <drJeckyll@hotmail.com>
*/

/* Some Config you may want to change */
#define ICU_95

#include <gkrellm/gkrellm.h>

#include <stdlib.h>
#include <stdio.h>
#include <gnome.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdarg.h>
#include <errno.h>
#include <unistd.h>
#include <netinet/in.h>
#include <pwd.h>

#define CONFIG_NAME "IcuKrell"
#define STYLE_NAME  "icukrell"

#define ICU_NO_MSGS             "No msg's"
#define ICU_DOWN                "ICU down"
#define ICU_OFFLINE             "Offline"
#define ICU_ONLINE              "Online"
#define ICU_INVISIBLE           "Invisible"
#define ICU_NA_99A              "N/A"
#define ICU_NA                  "N/A"
#define ICU_FREE_CHAT           "Free4Chat"
#define ICU_OCCUPIED_MAC        "Occupied"
#define ICU_OCCUPIED            "Occupied"
#define ICU_AWAY                "Away"
#define ICU_DND                 "DND"

#define ICU_MAIN_VISIBLE        1
#define ICU_MAIN_INVISIBLE      0

static Panel *panel;
static Decal *decal_text_status, *decal_text_msg_count, *decal_pic;
static gchar *message_status = ICU_DOWN;
static gchar *message_msg_count = ICU_NO_MSGS;
static gint style_id;

int socket_fd;

#include "xpm/offline.xpm"
GdkPixmap *offline_pixmap;
GdkBitmap *offline_bitmap;
#include "xpm/online.xpm"
GdkPixmap *online_pixmap;
GdkBitmap *online_bitmap;
#include "xpm/invisible.xpm"
GdkPixmap *invisible_pixmap;
GdkBitmap *invisible_bitmap;
#include "xpm/na.xpm"
GdkPixmap *na_pixmap;
GdkBitmap *na_bitmap;
#include "xpm/free4chat.xpm"
GdkPixmap *free4chat_pixmap;
GdkBitmap *free4chat_bitmap;
#include "xpm/occupied.xpm"
GdkPixmap *occupied_pixmap;
GdkBitmap *occupied_bitmap;
#include "xpm/away.xpm"
GdkPixmap *away_pixmap;
GdkBitmap *away_bitmap;
#include "xpm/dnd.xpm"
GdkPixmap *dnd_pixmap;
GdkBitmap *dnd_bitmap;
#ifndef ICU_95
#include "xpm/message.xpm"
#else
#include "xpm/message-95.xpm"
#endif
GdkPixmap *message_pixmap;
GdkBitmap *message_bitmap;


static gint panel_expose_event(GtkWidget *widget, GdkEventExpose *ev)
{
        gdk_draw_pixmap(widget->window, widget->style->fg_gc[GTK_WIDGET_STATE (widget)], panel->pixmap, ev->area.x, ev->area.y, ev->area.x, ev->area.y, ev->area.width, ev->area.height);
        return FALSE;
}

static void update_status_pic()
{
        gint x, y;
        GdkPixmap *pixmap;
        GdkBitmap *mask;

        if (!strcmp(message_status, ICU_DOWN))
                gkrellm_make_decal_invisible(panel, decal_pic);
        else
        {
                pixmap = offline_pixmap;
                mask = offline_bitmap;

                if (!strcmp(message_status, ICU_OFFLINE))
                {
                        pixmap = offline_pixmap;
                        mask = offline_bitmap;
                }
                if (!strcmp(message_status, ICU_ONLINE))
                {
                        pixmap = online_pixmap;
                        mask = online_bitmap;
                }
                if (!strcmp(message_status, ICU_INVISIBLE))
                {
                        pixmap = invisible_pixmap;
                        mask = invisible_bitmap;
                }
                if (!strcmp(message_status, ICU_NA) || !strcmp(message_status, ICU_NA_99A))
                {
                        pixmap = na_pixmap;
                        mask = na_bitmap;
                }
                if (!strcmp(message_status, ICU_FREE_CHAT))
                {
                        pixmap = free4chat_pixmap;
                        mask = free4chat_bitmap;
                }
                if (!strcmp(message_status, ICU_OCCUPIED) || !strcmp(message_status, ICU_OCCUPIED_MAC))
                {
                        pixmap = occupied_pixmap;
                        mask = occupied_bitmap;
                }
                if (!strcmp(message_status, ICU_AWAY))
                {
                        pixmap = away_pixmap;
                        mask = away_bitmap;
                }
                if (!strcmp(message_status, ICU_DND))
                {
                        pixmap = dnd_pixmap;
                        mask = dnd_bitmap;
                }

                x = gkrellm_chart_width() - 20;
                y = decal_text_status->y + 3;
                gkrellm_make_decal_invisible(panel, decal_pic);
                decal_pic = gkrellm_create_decal_pixmap(panel, pixmap, mask, 1, NULL, x, y);
                gkrellm_draw_decal_pixmap(panel, decal_pic, 0);
                gkrellm_make_decal_visible(panel, decal_pic);

                gkrellm_make_decal_visible(panel, decal_text_msg_count);
        }
}

static void update_plugin()
{
        struct sockaddr_un addr;
        gchar *user;
        struct passwd *pw;
        gchar new_message_status[100] = ICU_DOWN;
        gchar new_message_msg_count[100];
        gchar *new_message_full;
        unsigned long u;
        gchar *buffer;
        gchar c = 1;
        gint x, y;
        GdkPixmap *pixmap;
        GdkBitmap *mask;

        if ((GK.timer_ticks % 2) == 0)
        {
                pw = getpwuid(getuid());
                user = g_strdup(pw->pw_name);

                sprintf(addr.sun_path, "/tmp/.gnomeicu-%s/ctl", user);

                addr.sun_family = AF_UNIX;

                if (!access(addr.sun_path, R_OK) != 0)
                {
                        socket_fd = socket(AF_UNIX, SOCK_STREAM, 0);

                        if(socket_fd >= 0)
                        {
                                if (connect(socket_fd, (struct sockaddr *)&addr, sizeof(addr.sun_family) + strlen(addr.sun_path) + 1) == 0)
                                {
                                        strcpy(new_message_status, "PRB");

                                        buffer = g_malloc0(8192);

                                        strcat(buffer, "icuask");
                                        strcat(buffer, " ");
                                        c = 9;

                                        u = htonl(strlen(buffer) + 1);

                                        write(socket_fd, &c, 1);
                                        write(socket_fd, &u, sizeof(unsigned long));
                                        write(socket_fd, buffer, strlen(buffer)+1);

                                        g_free(buffer);

                                        read(socket_fd, &u, sizeof(unsigned long));
                                        u = g_htonl(u);
                                        if (u < 16384)
                                        {
                                                buffer = g_malloc0(u);
                                                read(socket_fd, buffer, u);

                                                new_message_full = strdup(buffer);
                                                strcpy(new_message_status, strtok(buffer, " "));
                                                strcpy(new_message_msg_count, strtok(NULL, " "));

                                                if (!strcmp(new_message_msg_count, "0"))
                                                        strcpy(new_message_msg_count, ICU_NO_MSGS);
                                                else
                                                        if (!strcmp(new_message_msg_count, "1"))
                                                                sprintf(new_message_msg_count, "%s msg", new_message_msg_count);
                                                        else
                                                                sprintf(new_message_msg_count, "%s msg's", new_message_msg_count);

                                                g_free(buffer);
                                        }

                                        close(socket_fd);
                                } else strcpy(new_message_status, ICU_DOWN);
                        }
                } else strcpy(new_message_status, ICU_DOWN);

                if (strcmp(message_status, new_message_status))
                {
                        message_status = g_strdup(new_message_status);
                        decal_text_status->x_off = 1;
                        gkrellm_draw_text_decal(panel, decal_text_status, message_status, decal_text_status->x_off);
                        decal_text_status->x_off = 0;
                        gkrellm_draw_text_decal(panel, decal_text_status, message_status, decal_text_status->x_off);

                        if (!strcmp(message_status, ICU_DOWN))
                                gkrellm_make_decal_invisible(panel, decal_text_msg_count);

                        update_status_pic();
                }

                if (strcmp(message_msg_count, new_message_msg_count))
                {
                        message_msg_count = g_strdup(new_message_msg_count);
                        decal_text_msg_count->x_off = 1;
                        gkrellm_draw_text_decal(panel, decal_text_msg_count, message_msg_count, decal_text_msg_count->x_off);
                        decal_text_msg_count->x_off = 0;
                        gkrellm_draw_text_decal(panel, decal_text_msg_count, message_msg_count, decal_text_msg_count->x_off);

                        if (strcmp(message_status, ICU_DOWN))
                        {
                                if (strcmp(new_message_msg_count, ICU_NO_MSGS))
                                {
                                        pixmap = message_pixmap;
                                        mask = message_bitmap;
                                        x = gkrellm_chart_width() - 20;
                                        y = decal_text_status->y + 3;
                                        gkrellm_make_decal_invisible(panel, decal_pic);
                                        decal_pic = gkrellm_create_decal_pixmap(panel, pixmap, mask, 1, NULL, x, y);
                                        gkrellm_make_decal_visible(panel, decal_pic);
                                        gkrellm_draw_decal_pixmap(panel, decal_pic, 0);
                                } else update_status_pic();
                        }
                }

                if (strcmp(message_msg_count, ICU_NO_MSGS) && strcmp(message_status, ICU_DOWN))
                {
                        if ((GK.timer_ticks % 4) == 0)
                                gkrellm_make_decal_visible(panel, decal_pic);
                        else
                                gkrellm_make_decal_invisible(panel, decal_pic);
                }

                gkrellm_draw_layers(panel);
        }
}

static void create_plugin(GtkWidget *vbox, gint first_create)
{
        Style *style;
        TextStyle *ts, *ts_alt;
        GdkPixmap *pixmap;
        GdkBitmap *mask;
        gint x, y;
        GdkImlibImage *im;

        if (first_create) panel = gkrellm_panel_new0(); else gkrellm_destroy_decal_list(panel);
        style = gkrellm_meter_style(style_id);

        ts = gkrellm_meter_textstyle(style_id);
        ts_alt = gkrellm_meter_alt_textstyle(style_id);
        panel->textstyle = ts;

        // create images
        im = gdk_imlib_create_image_from_xpm_data(offline_xpm);
        gdk_imlib_render(im, im->rgb_width, im->rgb_height);
        offline_pixmap = gdk_imlib_copy_image(im);
        offline_bitmap = gdk_imlib_copy_mask(im);
        gdk_imlib_destroy_image(im);

        im = gdk_imlib_create_image_from_xpm_data(online_xpm);
        gdk_imlib_render(im, im->rgb_width, im->rgb_height);
        online_pixmap = gdk_imlib_copy_image(im);
        online_bitmap = gdk_imlib_copy_mask(im);
        gdk_imlib_destroy_image(im);

        im = gdk_imlib_create_image_from_xpm_data(invisible_xpm);
        gdk_imlib_render(im, im->rgb_width, im->rgb_height);
        invisible_pixmap = gdk_imlib_copy_image(im);
        invisible_bitmap = gdk_imlib_copy_mask(im);
        gdk_imlib_destroy_image(im);

        im = gdk_imlib_create_image_from_xpm_data(na_xpm);
        gdk_imlib_render(im, im->rgb_width, im->rgb_height);
        na_pixmap = gdk_imlib_copy_image(im);
        na_bitmap = gdk_imlib_copy_mask(im);
        gdk_imlib_destroy_image(im);

        im = gdk_imlib_create_image_from_xpm_data(free4chat_xpm);
        gdk_imlib_render(im, im->rgb_width, im->rgb_height);
        free4chat_pixmap = gdk_imlib_copy_image(im);
        free4chat_bitmap = gdk_imlib_copy_mask(im);
        gdk_imlib_destroy_image(im);

        im = gdk_imlib_create_image_from_xpm_data(occupied_xpm);
        gdk_imlib_render(im, im->rgb_width, im->rgb_height);
        occupied_pixmap = gdk_imlib_copy_image(im);
        occupied_bitmap = gdk_imlib_copy_mask(im);
        gdk_imlib_destroy_image(im);

        im = gdk_imlib_create_image_from_xpm_data(away_xpm);
        gdk_imlib_render(im, im->rgb_width, im->rgb_height);
        away_pixmap = gdk_imlib_copy_image(im);
        away_bitmap = gdk_imlib_copy_mask(im);
        gdk_imlib_destroy_image(im);

        im = gdk_imlib_create_image_from_xpm_data(dnd_xpm);
        gdk_imlib_render(im, im->rgb_width, im->rgb_height);
        dnd_pixmap = gdk_imlib_copy_image(im);
        dnd_bitmap = gdk_imlib_copy_mask(im);
        gdk_imlib_destroy_image(im);

        im = gdk_imlib_create_image_from_xpm_data(message_xpm);
        gdk_imlib_render(im, im->rgb_width, im->rgb_height);
        message_pixmap = gdk_imlib_copy_image(im);
        message_bitmap = gdk_imlib_copy_mask(im);
        gdk_imlib_destroy_image(im);
        // end of creating images

        decal_text_status = gkrellm_create_decal_text(panel, message_status, ts_alt, style, -1, 4, -1);
        y = decal_text_status->y + decal_text_status->h + 4;
        decal_text_msg_count = gkrellm_create_decal_text(panel, message_msg_count, ts_alt, style, 2, y, 0);

        pixmap = offline_pixmap;
        mask = offline_bitmap;
        x = gkrellm_chart_width() - 20;
        y = decal_text_status->y + 2;
        decal_pic = gkrellm_create_decal_pixmap(panel, pixmap, mask, 1, NULL, x, y);

        gkrellm_configure_panel(panel, NULL, style);
        panel->label->h_panel += 2;
        gkrellm_create_panel(vbox, panel, gkrellm_bg_meter_image(style_id));
        gkrellm_monitor_height_adjust(panel->h);

        gkrellm_draw_decal_text(panel, decal_text_status, message_status, 1);
        gkrellm_draw_decal_text(panel, decal_text_msg_count, message_msg_count, 1);
        gkrellm_make_decal_invisible(panel, decal_text_msg_count);
        gkrellm_draw_decal_pixmap(panel, decal_pic, 0);
        gkrellm_make_decal_invisible(panel, decal_pic);

        if (first_create) gtk_signal_connect(GTK_OBJECT (panel->drawing_area), "expose_event", (GtkSignalFunc) panel_expose_event, NULL);
}

static Monitor plugin_monitor =
{
        CONFIG_NAME,                    /* Name, for config tab.             */
        0,                              /* Id,  0 if a plugin                */
        create_plugin,                  /* The create function               */
        update_plugin,                  /* The update function               */
        NULL,                           /* The config tab create function    */
        NULL,                           /* Apply the config function         */
        NULL,                           /* Save user config                  */
        NULL,                           /* Load user config                  */
        NULL,                           /* config keyword                    */
        NULL,                           /* Undefined 2                       */
        NULL,                           /* Undefined 1                       */
        NULL,                           /* private                           */
        MON_MAIL,                       /* Insert plugin before this monitor */
        NULL,                           /* Handle if a plugin, filled in by GkrellM */
        NULL,                           /* path if a plugin, filled in by GKrellM   */
};

Monitor *init_plugin()
{
        style_id = gkrellm_add_meter_style(&plugin_monitor, STYLE_NAME);
        return &plugin_monitor;
}
